﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGScrollIntoViewDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        private void scrollViewBtn_Click(object sender, RoutedEventArgs e)
        {
            int? index = null;

            try
            {
                index = int.Parse(indexTB.Text);
            }
            catch(Exception ex)
            {
                MessageBox.Show("Please enter a valid integer.");
            }

            if(index != null)
            {
                if (index < 0)
                {
                    MessageBox.Show("Please enter a value greater than 0");
                }
                else if (index > XDG1.Records.Count - 1)
                {
                    MessageBox.Show("Please enter a value less than " + (XDG1.Records.Count - 1).ToString());
                }
                else
                {
                    DataRecord record = XDG1.Records[(int)index] as DataRecord;

                    var recordsInView = XDG1.GetRecordsInView(true);

                    int inViewCount = recordsInView.Count();

                    int middleOfInViewCount = inViewCount / 2;

                    XDG1.SelectedItems.Records.Clear();
                    XDG1.SelectedItems.Records.Add(record);

                    int firstViewedRecordIndex = recordsInView[0].Index;

                    int calculatedScrollIndex = 0;

                    //First viewed record is below scroll-record. Else - above.
                    if(firstViewedRecordIndex <= index)
                    {
                        calculatedScrollIndex = (int)index + middleOfInViewCount;                    
                    }                    
                    else
                    {
                        calculatedScrollIndex = (int)index - middleOfInViewCount;
                    }


                    if (calculatedScrollIndex >= XDG1.Records.Count - 1)
                    {
                        XDG1.BringRecordIntoView(XDG1.Records[XDG1.Records.Count - 1]);
                    }
                    else if(calculatedScrollIndex <= 0)
                    {
                        XDG1.BringRecordIntoView(XDG1.Records[0]);
                    }
                    else
                    {
                        XDG1.BringRecordIntoView(XDG1.Records[calculatedScrollIndex]);
                    }
                }
            }           
        }
    }
}
